## net.sf.saxon.tree.iter
Class SingletonIterator

    java.lang.Object
      net.sf.saxon.tree.iter.SingletonIterator

All Implemented Interfaces:
  LastPositionFinder, SequenceIterator, GroundedIterator, LookaheadIterator, ReversibleIterator, UnfailingIterator

    public class SingletonIterator

extends Object
implements UnfailingIterator, ReversibleIterator, LastPositionFinder, GroundedIterator, LookaheadIterator

SingletonIterator: an iterator over a sequence of zero or one values

Field Summary

Fields inherited from interface net.sf.saxon.om.SequenceIterator
`GROUNDED, LAST_POSITION_FINDER, LOOKAHEAD`

Method Summary
`void` `close()` Close the iterator.
`Item` `current()` Get the current item in the sequence.
`SequenceIterator` `getAnother()` Get another iterator over the same sequence of items, positioned at the start of the sequence.
`int` `getLastPosition()` Get the last position (that is, the number of items in the sequence).
`int` `getProperties()` Get properties of this iterator, as a bit-significant integer.
`SequenceIterator` `getReverseIterator()` Get a new SequenceIterator that returns the same items in reverse order.
`Item` `getValue()`
`boolean` `hasNext()` Determine whether there are more items to come.
`static UnfailingIterator` `makeIterator(Item item)` Factory method.
`GroundedValue` `materialize()` Return a Value containing all the items in the sequence returned by this SequenceIterator
`Item` `next()` Get the next item in the sequence.
`int` `position()` Return the current position in the sequence.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Method Detail

### makeIterator

    public static UnfailingIterator makeIterator(Item item)

  Factory method.

  Parameters:
    `item` - the item to iterate over
  Returns:
    a SingletonIterator over the supplied item, or an EmptyIterator if the supplied item is null.

### hasNext

    public boolean hasNext()

  Determine whether there are more items to come. Note that this operation is stateless and it is not necessary (or usual) to call it before calling next(). It is used only when there is an explicit need to tell if we are at the last element.

  Specified by:
    `hasNext` in interface `LookaheadIterator`
  Returns:
    true if there are more items

### next

    public Item next()

  Description copied from interface: `UnfailingIterator`
  Get the next item in the sequence.

  Specified by:
    `next` in interface `SequenceIterator`
  Specified by:
    `next` in interface `UnfailingIterator`
  Returns:
    the next Item. If there are no more nodes, return null.

### current

    public Item current()

  Description copied from interface: `UnfailingIterator`
  Get the current item in the sequence.

  Specified by:
    `current` in interface `SequenceIterator`
  Specified by:
    `current` in interface `UnfailingIterator`
  Returns:
    the current item, that is, the item most recently returned by next()

### position

    public int position()

  Return the current position in the sequence.

  Specified by:
    `position` in interface `SequenceIterator`
  Specified by:
    `position` in interface `UnfailingIterator`
  Returns:
    0 before the first call on next(); 1 before the second call on next(); -1 after the second call on next().

### getLastPosition

    public int getLastPosition()

  Description copied from interface: `LastPositionFinder`
  Get the last position (that is, the number of items in the sequence). This method is non-destructive: it does not change the state of the iterator. The result is undefined if the next() method of the iterator has already returned null. This method must not be called unless the result of getProperties() on the iterator includes the bit setting `SequenceIterator.LAST_POSITION_FINDER`

  Specified by:
    `getLastPosition` in interface `LastPositionFinder`

### close

    public void close()

  Description copied from interface: `SequenceIterator`
  Close the iterator. This indicates to the supplier of the data that the client does not require any more items to be delivered by the iterator. This may enable the supplier to release resources. After calling close(), no further calls on the iterator should be made; if further calls are made, the effect of such calls is undefined.

  (Currently, closing an iterator is important only when the data is being "pushed" in another thread. Closing the iterator terminates that thread and means that it needs to do no additional work. Indeed, failing to close the iterator may cause the push thread to hang waiting for the buffer to be emptied.)

  Specified by:
    `close` in interface `SequenceIterator`

### getAnother

    public SequenceIterator getAnother()

  Description copied from interface: `UnfailingIterator`
  Get another iterator over the same sequence of items, positioned at the start of the sequence. It must be possible to call this method at any time, whether none, some, or all of the items in the original iterator have been read. The method is non-destructive: it does not change the state of the original iterator.

  Specified by:
    `getAnother` in interface `SequenceIterator`
  Specified by:
    `getAnother` in interface `UnfailingIterator`
  Returns:
    a new iterator over the same sequence

### getReverseIterator

    public SequenceIterator getReverseIterator()

  Description copied from interface: `ReversibleIterator`
  Get a new SequenceIterator that returns the same items in reverse order. If this SequenceIterator is an AxisIterator, then the returned SequenceIterator must also be an AxisIterator.

  Specified by:
    `getReverseIterator` in interface `ReversibleIterator`
  Returns:
    an iterator over the items in reverse order

### getValue

    public Item getValue()

### materialize

    public GroundedValue materialize()

  Return a Value containing all the items in the sequence returned by this SequenceIterator

  Specified by:
    `materialize` in interface `GroundedIterator`
  Returns:
    the corresponding Value. If the value is a closure or a function call package, it will be evaluated and expanded.

### getProperties

    public int getProperties()

  Get properties of this iterator, as a bit-significant integer.

  Specified by:
    `getProperties` in interface `SequenceIterator`
  Returns:
    the properties of this iterator. This will be some combination of properties such as `SequenceIterator.GROUNDED`, `SequenceIterator.LAST_POSITION_FINDER`, and `SequenceIterator.LOOKAHEAD`. It is always acceptable to return the value zero, indicating that there are no known special properties. It is acceptable for the properties of the iterator to change depending on its state.

Copyright (c) 2004-2010 Saxonica Limited. All rights reserved.